#include <stdio.h>
//#include <stdlib.h>
#include <math.h>
#include <GL/glut.h>

int n=25, m=8;

#define X(i,j) sin(M_PI*(2*i+(j%2))/n)*j/m
#define Y(i,j) cos(M_PI*(2*i+(j%2))/n)*j/m

#define XY(i,j) X((i),(j)),Y((i),(j))

void init(void)
{
	
}

void point(int i, int j) {
	glVertex2f(XY(i,j+1));
	glVertex2f(XY(i+1,j+1));
	glVertex2f(XY((j%2)?i:i+1,j));
}

void display()
{
	int i,j;
	glClear(GL_COLOR_BUFFER_BIT);

	for(i=0;i<n;i++) {
		for(j=0;j<m-1;j++) {
			glColor3f(.5,.5,.5);
			glBegin(GL_POLYGON);
			point(i,j);
			glEnd();
			glColor3f(1,1,1);
			glBegin(GL_LINE_LOOP);
			point(i,j);
			glEnd();
		}
	}

	
	glFlush();
}

void reshape(int width, int height)
{
	glViewport( 0, 0, width, height );
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
}

void key(unsigned char key, int x, int y)
{
	switch (key) {
	case 27:
		exit(0);
		break;
	case '-':
		n--;
		glutPostRedisplay();
		break;
	case '=':
	case '+':
		n++;
		glutPostRedisplay();
		break;
	case 'a':
		m--;
		glutPostRedisplay();
		break;
	case 's':
		m++;
		glutPostRedisplay();
	}
}

int main( int argc, char **argv)
{
	glutInit(&argc, argv);
	glutInitWindowSize(600, 600);

	glutInitDisplayMode(GLUT_RGB);
	
	glutCreateWindow(*argv);
	
	glutKeyboardFunc(key);
	glutReshapeFunc(reshape);
	glutDisplayFunc(display);
	
	init();

	glutMainLoop();
}
